/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

var autopagerSelector= 
{
    commands:null,
    browser:null,
    mouseX:null,
    mouseY:null
}

autopagerSelector.commands = [
	"select",
	"wider",
	"narrower",
	"quit",
	"blinkElement",
	"viewSource",
	"viewSourceWindow",
	"showMenu"
];
autopagerSelector.initHelpBox = function() {
	var helpBoxRows = document.getElementById("autopager-helpbox-rows");
	if (helpBoxRows.firstChild)
		return;

	// Help box hasn't been filled yet, need to do it now
	var stringService = Components.classes["@mozilla.org/intl/stringbundle;1"]
																.getService(Components.interfaces.nsIStringBundleService);
	var strings = stringService.createBundle("chrome://autopager/locale/commands.properties");

	for (var i = 0; i < this.commands.length; i++) {
		var command = this.commands[i];
		var key = strings.GetStringFromName("command." + command + ".key");
		var label = strings.GetStringFromName("command." + command + ".label");
		this.commands[command + "_key"] = key.toLowerCase();
		this.commands[command + "_label"] = label;

		var row = document.createElement("row");
		helpBoxRows.appendChild(row);

		var element = document.createElement("description");
		element.setAttribute("value", key);
		element.className = "key";
		row.appendChild(element);

		element = document.createElement("description");
		element.setAttribute("value", label);
		element.className = "label";
		row.appendChild(element);
	}
}
//-------------------------------------------------
autopagerSelector.showMenu = function ()
{
	var helpBox = document.getElementById("autopager-helpbox");
        if (helpBox==null)
            helpBox = document.getElementById("autopager-helpbox");
	if (helpBox.getAttribute("_moz-menuactive") == "true") {
		helpBox.hidePopup();
		return true;
	}

	// Show help box
	helpBox.showPopup(this.browser, -1, -1, "tooltip", "topleft", "topleft");
	return true;
}

autopagerSelector.doCommand = function(command, event) {
	if (this[command](this.selectedElem)) {
		this.showCommandLabel(this.commands[command + "_key"], this.commands[command + "_label"]);
		if (event)
			event.stopPropagation();
	}
	if (event)
		event.preventDefault();
}

autopagerSelector.showCommandLabel = function(key, label) {
	if (this.commandLabelTimeout)
		clearTimeout(this.commandLabelTimeout);

	document.getElementById("autopager-commandlabel-key").setAttribute("value", key);
	document.getElementById("autopager-commandlabel-label").setAttribute("value", label);

	var commandLabel = document.getElementById("autopager-commandlabel");
	commandLabel.showPopup(document.documentElement, this.mouseX, this.mouseY, "tooltip", "topleft", "topleft");

	this.commandLabelTimeout = setTimeout(function() {
		commandLabel.hidePopup();
		autopagerSelector.commandLabelTimeout = 0;
	}, 400);
}

autopagerSelector.onKeyPress = function(event) {
	if (event.altKey || event.ctrlKey || event.metaKey)
		return;

	var command = null;
	if (event.keyCode == event.DOM_VK_ESCAPE)
		command = "quit";
	else if (event.keyCode == event.DOM_VK_RETURN)
		command = "select";
	else if (event.charCode) {
		var key = String.fromCharCode(event.charCode).toLowerCase();
		var commands = this.commands;
		for (var i = 0; i < commands.length; i++)
			if (commands[commands[i] + "_key"] == key)
				command = commands[i];
	}

	if (command)
		this.doCommand(command, event);
}
    